include "Zeropage.inc"
include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext CharColors_
ext Chars_
ext VVram_

VramTop equ Vram

pSource equ ZW0
pDestination equ ZW1
yCount equ ZB0
xCount equ ZB1
sourceOffset equ ZB2
destinationOffset equ ZB3
sourceByte equ ZB4


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    pha
        lda #low VVram_ | sta <pSource
        lda #high VVram_ | sta <pSource+1
        lda #low VramTop | sta <pDestination
        lda #high VramTop | sta <pDestination+1

        lda #VVramHeight | sta <yCount
        do
            ldy #0
            lda (<pSource),y
            tax
            lda CharColors_,x
            sta (<pDestination),y
            do
                lda (<pSource),y
                cmp #Char_Space
                if eq
                    iny | lda (<pSource),y | dey
                    tax
                    lda CharColors_,x
                    ; if eq
                    ;     lda #Char_Space
                    ; endif
                endif
                iny
                sta (<pDestination),y
                cpy #VVramWidth-1
            while ne | wend
            lda (<pSource),y 
            iny
            sta (<pDestination),y

            lda <pSource | clc | adc #low VVramWidth | sta <pSource
            lda <pSource+1 | adc #high VVramWidth | sta <pSource+1
            lda <pDestination | clc | adc #low VramRowSize | sta <pDestination
            lda <pDestination+1 | adc #high VramRowSize | sta <pDestination+1

            dec <yCount
        while ne | wend
    pla
rts


; void CopyPattern(byte c, byte pattern, byte count);
cseg
Multi8:
    sta <0,x
    lda #0 | sta <1,x
    asl <0,x | rol <1,x ;*2
    asl <0,x | rol <1,x ;*4
    asl <0,x | rol <1,x ;*8
rts

dseg
CopyPattern_@Param0: public CopyPattern_@Param0
    defb 0
CopyPattern_@Param1: public CopyPattern_@Param1
    defb 0
CopyPattern_@Param2: public CopyPattern_@Param2
    defb 0

cseg
CopyPattern_: public CopyPattern_
    pha
        lda CopyPattern_@Param0
        ldx #pDestination | jsr Multi8
        lda <pDestination | clc|adc #low PatternRam | sta <pDestination
        lda <pDestination+1 | adc #high PatternRam | sta <pDestination+1

        lda CopyPattern_@Param1
        ldx #pSource | jsr Multi8
        lda <pSource | clc|adc #low Chars_ | sta <pSource
        lda <pSource+1 | adc #high Chars_ | sta <pSource+1
        
        ldx CopyPattern_@Param2
        do
            ldy #0
            do
                lda (pSource),y
                sta (pDestination),y
                iny
                cpy #8
            while ne | wend
            lda <pSource | clc|adc #8 | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1

            lda <pDestination | clc|adc #8 | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1
         dex
        while ne | wend
    pla
rts


; ptr<byte> PrintC(ptr<byte> pDestination, byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_.pDestination_:	defs 2
PrintC_@Param1: public PrintC_@Param1
PrintC_.c_:	defs 1
cseg
CharTable:
    defb '-0123456789ACEFGHIKMNOPRSTUVY'
PrintC_: public PrintC_
    pha
        lda PrintC_@Param1
        ldx #0
        do
            cmp CharTable,x
            beq PrintC_exit
            inx
            cpx #29
        while ne | wend
        ldx #Char_Space-Char_Ascii
        PrintC_exit:        
        lda PrintC_@Param0 | sta <pDestination
        lda PrintC_@Param0+1 | sta <pDestination+1
        txa
        ldy #0
        clc|adc #Char_Ascii
        sta (<pDestination),y

        lda <pDestination | clc|adc #1 | tay
        lda <pDestination+1 | adc #0 | tax
    pla
rts
